//Compatibility file
local SKIN = "cosmetal"

freeslot("SPR2_OOF_", "SPR2_JSKI")

//Ringslinger [N E O]
local rs_loaded = false
addHook("ThinkFrame", do
	if RingSlinger and not rs_loaded
		rs_loaded = true;
		
		print("Cosmetal is ready to shoot!")
		
		--Define RS NEO stuff here.
		RingSlinger.AddWeapon({
			name = "Energy Blast",--Weapon name
			viewsprite = "JETFA0",--”Viewmodel”
			hudsprite = "ENERIND",--Hud icon
			mt = MT_ENERGYBLAST,--Thrown object
			sound = sfx_s3k54,--Throw sound effect
			scale = FRACUNIT*3/4,--Object and viewmodel scale
			viewoffset = -23*FRACUNIT,--Viewmodel vertical offset
			auto = false,--Used for automatic ring’s autofire
			delay = 5,--Delay between shots in tics (mainhand)
			shake = 7,--Screenshake when thrown
			cost = 2--Ammo cost per shot
		})
		RingSlinger.Skins[SKIN] = {
			ammo = 45,
			weapons = {RSWPN_ENERGYBLAST, RSWPN_EXPLOSION}
		}
	end
end)

//Kirbo
if not(kirbyabilitytable)
	rawset(_G, "kirbyabilitytable", {})
end
kirbyabilitytable[SKIN] = 7 //Tornado

//RushChars Boat (not a boat)
if not boatchars
	rawset(_G, "boatchars", {})
end
boatchars[SKIN] = {0,1,1}

//Sol Emerald Form
if not solchars
	rawset(_G, "solchars", {})
end
solchars[SKIN] = {SKINCOLOR_SUPERGOLD1,2}

/*
	Classic Ring Attraction script by Golden.
	Replicates how rings attract to the player in Sonic 3&K and Sonic Mania.
*/

-- A list of objects to hook immediately during load.
local objects = {MT_RING, MT_FLINGRING}

-- Change an object's type without deleting it.
-- Not globalising because I don't want to cause
-- people to actually use this.
local function changeObjectType(mo, newType)
	mo.type = newType

	local info = mobjinfo[newType]

	-- Set several mobj variables to their new defaults.
	mo.health = info.spawnhealth
	mo.reactiontime = info.reactiontime
	mo.radius = info.radius
	mo.height = info.height
	mo.flags = info.flags
end

-- Apply ring momentum for ring attraction.
-- [12:40 AM] MT_FLAME: ["mom" .. dimension] is extremely crafty
local function doRingMomentum(mo, dimension)
	-- where dimension == "x"
	-- mo[dimension] == mo.x
	-- mo["mom" .. dimension] == mo.momx

	local followmo = mo.followmo

	-- When moving toward player, accelerate fast
	-- When moving away from player, accelerate slow
	-- Always try to go towards player.

	if followmo[dimension] > mo[dimension] then
		if mo["mom" .. dimension] > followmo["mom" .. dimension] then
			mo["mom" .. dimension] = $ + FRACUNIT
		else
			mo["mom" .. dimension] = $ + FRACUNIT*2
		end
	elseif followmo[dimension] < mo[dimension] then
		if mo["mom" .. dimension] < followmo["mom" .. dimension] then
			mo["mom" .. dimension] = $ - FRACUNIT
		else
			mo["mom" .. dimension] = $ - FRACUNIT*2
		end
	end
end

-- Perform classic ring attraction. And many checks. Soo many checks.
function A_ClassicRingAttract(mo)
	-- Don't do ANYTHING if the player hates lag!
	if not CMS.Check("mobjthinkers") then return end
	-- Don't attract the rancid decomposing dead rings!
	if mo.health == 0 then
		mo.followmo = nil
		return
	end

	-- Check if player exists and is in range, and if so, link them to us.
	-- Otherwise, don't continue.
	if not mo.followmo or not mo.followmo.valid
	or not mo.followmo.player or not mo.followmo.player.valid then
		local target = mo.target -- Get current target, cause P_SupermanLook4Players overwrites it.
		local success = P_SupermanLook4Players(mo, 0, true)
		if success then
			if P_AproxDistance(P_AproxDistance(mo.x-mo.target.x, mo.y-mo.target.y), mo.z-mo.target.z) > RING_DIST then
				mo.target = target
				return
			end
			mo.followmo = mo.target
			mo.target = target
		else
			return
		end
	end

	local followmo = mo.followmo

	-- If the player isn't Golden Cosmetal, fling off!
	if not (followmo.player.solchar and followmo.player.solchar.istransformed and followmo.skin == SKIN) then
		mo.flags = $ & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT & ~MF_NOGRAVITY
		mo.followmo = nil

		if mo.attractive then -- But only if we're too good for them.
			if mo.type == MT_RING then
				changeObjectType(mo, MT_FLINGRING)
				mo.fuse = 10*TICRATE
			end
			mo.attractive = false -- Someone forgot to put on makeup...
		end

		return
	else
		mo.attractive = true -- We're beautiful
	end

	mo.fuse = 0 -- Never disappear

	mo.flags = $ | MF_NOCLIP | MF_NOCLIPHEIGHT | MF_NOGRAVITY -- Go through everything

	-- Do the actual movement
	doRingMomentum(mo, "x")
	doRingMomentum(mo, "y")
	doRingMomentum(mo, "z")

	mo.state = mo.state -- Update state

	P_SetOrigin(mo, mo.x + mo.momx, mo.y + mo.momy, mo.z + mo.momz) -- Update position using momentum.

	return true -- Skip ring thinker.
end

-- For each object type in objects, hook A_ClassicRingAttract to their thinker.
-- Yes, this is valid Lua code.
for _, v in ipairs(objects) do
	addHook("MobjThinker", A_ClassicRingAttract, v)
end

