-- gotta go faster --

local TOPSPEED = 100*FRACUNIT -- Cap speed for dashmode.
local HAVETOPSPEED = true
local RUNTIME = 20*FRACUNIT -- How long do you have to run for to activate dashmode.
local DEFNORMALSPEED = 48*FRACUNIT -- Put your default normal speed here.
local MAXJUMPHIGHT = 2*FRACUNIT -- Maximum jump power when in dashmode.
local SKIN = "cosmetal" -- Your character's skin name goes here.

local function ResetVars(player) -- Resets vars
player.runtime = 0
player.normalspeed = DEFNORMALSPEED
player.fakenormalspeed = DEFNORMALSPEED
player.jumpfactor = 1*FRACUNIT
player.maxspeedentersound = false
end

local function DoNormalSpeed(player) -- Raises Top Speed
	if player.fakenormalspeed == nil then player.fakenormalspeed = DEFNORMALSPEED 
	return end
	if HAVETOPSPEED == true
		if player.fakenormalspeed < TOPSPEED and player.speeddash == true and player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.fakenormalspeed = $1 + 2*FRACUNIT/5  
		end
		if player.normalspeed < TOPSPEED and player.speeddash == true and not player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.normalspeed = $1 + 2*FRACUNIT/5 
		end
		if player.jumpfactor < MAXJUMPHIGHT and player.speeddash == true
			player.jumpfactor = $1 + 1*FRACUNIT/100
		end
	else
		if player.speeddash == true and player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.fakenormalspeed = $1 + 2*FRACUNIT/5  
		end
		if player.speeddash == true and not player.isxmomentum and P_IsObjectOnGround(player.mo)
			player.normalspeed = $1 + 2*FRACUNIT/5 
		end
		if player.jumpfactor < MAXJUMPHIGHT and player.speeddash == true
			player.jumpfactor = $1 + 1*FRACUNIT/100
		end
	end
end

addHook("PlayerThink", function(player)
	if player.mo.skin == SKIN and player.mo.sprite2 != SPR2_JSKI then
		if not player.cmsHyper
			DoNormalSpeed(player) -- Does everything for normal speed.

			if (player.speed > 27*FRACUNIT or player.pflags&PF_STARTDASH) and not (leveltime % 5) -- Checks if you are running.
			if player.runtime == nil then player.runtime = 0 return true end
				player.runtime = $ + 1*FRACUNIT
			end
			if player.speed < 25*FRACUNIT and P_IsObjectOnGround(player.mo) and not (player.pflags&PF_STARTDASH) or P_PlayerInPain(player) -- Disables dashmode
				if player.speeddash == true then
				S_StartSound(player.mo, sfx_kc65) -- Exiting dashmode soundeffect.
				player.speeddash = false
				end
				ResetVars(player)
			end
		end
		if player.speeddash == true or player.cmsHyper
			if (player.panim == PA_RUN and player.speed >= player.runspeed) or player.secondjump
				player.mo.state = S_PLAY_DASH
			end
			player.charflags = $1|SF_RUNONWATER -- Enables Running on water.
		else
			if player.panim == PA_DASH and not player.rboosting
				player.mo.state = S_PLAY_RUN
			end
			player.charflags = $1 & ~SF_RUNONWATER
		end
	end
end)

addHook("PlayerThink", function(player) -- Default Dashmode Activation
	if player.mo.skin == SKIN and player.mo.sprite2 != SPR2_JSKI then
		if player.runtime == nil then player.runtime = 0 return true end
		if not player.speeddash == true
		and player.runtime >= RUNTIME
			if player.hyper and player.hyper.capable == true and player.powers[pw_super]
				P_NukeEnemies(player.mo, player.mo, 1536*FRACUNIT)
				if (player == displayplayer)
					P_StartQuake(50*FRACUNIT, 10)
				end
			elseif player.powers[pw_super] or (player.solchar and player.solchar.transformed)
				P_NukeEnemies(player.mo, player.mo, 768*FRACUNIT)
				if (player == displayplayer)
					P_StartQuake(25*FRACUNIT, 10)
				end
			else
				P_StartQuake(12*FRACUNIT, 10)
			end
			S_StartSound(player.mo, sfx_kc4d) -- Entering dashmode soundeffect
			player.speeddash = true
			if not player.xmomentum
				if player.speed >= player.normalspeed
					player.normalspeed = player.speed
				end
			else
				if player.speed >= player.fakenormalspeed
					player.fakenormalspeed = player.speed
				end
			end
		end
	end
end)

addHook("PlayerSpawn", function(player)
	if not (player.mo and player.mo.valid) or player.mo.skin != "cosmetal" then return end
	//player.metaldj = false
	player.metalimage = nil
	player.winsound = false
	player.waitTimer = 0
	if player.jumpabil == nil
		player.jumpabil = 1
	end
	player.mo.rollangle = 0
	player.deathtimer = 0
	if player.metalshield != nil
		P_SwitchShield(player, player.metalshield)
	end
	ResetVars(player)
	player.imagecount = 0
end)

addHook("PlayerCanDamage", function(p)
	if not(p.mo and p.mo.valid and p.mo.skin == SKIN) then return end
	if p.speeddash
		return true
	end
end)

addHook("MobjMoveCollide", function(mo, spike) -- Spike breaking adapted from code by ARJr.
    if mo.valid
    and (mo.type == MT_PLAYER)
	and (mo.player.speeddash or mo.player.cmsHyper)
    and spike.type == MT_SPIKE
		if (spike.z >= (mo.z - spike.height/2)) and (spike.z <= (mo.z + mo.height + spike.height/2))
			P_KillMobj(spike, mo, mo)
		elseif (spike.flags2 & MF2_OBJECTFLIP)
		and (spike.z <= (mo.z - spike.height/2)) and (spike.z >= (mo.z + mo.height + spike.height/2))
			P_KillMobj(spike, mo, mo)
        end
    end
end)

//No Damage when dashmode adapted from code by SMS Alfredo
addHook("MobjDamage", function(target, inflictor, source, damage, damagetype)
	if target.player and not (damagetype&DMG_DEATHMASK)
	and target.player.speeddash
		return true
	end
end, MT_PLAYER)

//Player Height thing
addHook("PlayerHeight", function(p)
	if p.speeddash and P_IsObjectOnGround(p.mo)
		return skins[p.mo.skin].spinheight
	elseif P_IsObjectOnGround(p.mo) and not(p.pflags&PF_SPINNING)
		return skins[p.mo.skin].height
	end
end)

addHook("PlayerCanEnterSpinGaps", function(p)
	if p.speeddash
		return true
	elseif P_IsObjectOnGround(p.mo) and not(p.pflags&PF_SPINNING)
		return false
	end
end)