local PRT_STND = {"cosmetal", SPR2_STND, A, 8}
local PRT_EDGE = {"cosmetal", SPR2_EDGE, A, 8}
local PRT_PONT = {"cosmetal", SPR2_WAIT, A, 8}
local PRT_MDJ = {"cosmetal", SPR2_TBXA, A, 0}
local PRT_OFF = {"cosmetal", SPR2_TBXA, B, 0}
local PRT_QUES = {"cosmetal", SPR2_TBXA, C, 0}
local MUSICSTEP = MUSICRATE/TICRATE

CMS.DialogueBoxes = {
	["tutorial"] = {
		[1] = {
			name = "Cosmetal",
			portrait = PRT_OFF,
			color = SKINCOLOR_METALLIX,
			noskip = true,
			noadvance = true,
			text = "|del12LOADING COSMETAL TUTORIAL PROGRAM\n|del16------------------------",
			delay = TICRATE/2,
			next = 17
		},
		[17] = {
			name = "Cosmetal",
			portrait = PRT_STND,
			sound = sfx_talk0,
			color = SKINCOLOR_METALLIX,
			text = "Hey there! Is this your first time playing as me?",
			next = 2
		},
		
		[2] = {
			choices = {
				{text = "Yes", box = 4, pos = "left"},
				{text = "No", box = 3, pos = "right"}
			}
		},
		
		[3] = {
			name = "Cosmetal", 
			portrait = PRT_EDGE,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Alright, I'll leave you be. Enjoy!",
			script = function(p)
				CMS.Set("tutorial", true)
			end,
			next = 0
		},
		
		[4] = {
			name = "Cosmetal",
			portrait = PRT_STND,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Ok, so the way I control should be simple|pau10:\nJumping and then jumping again\ncan do |wavone|rst of |wavtwo|rst things.",
			next = 5
		},
		
		[5] = {
			name = "Cosmetal",
			portrait = PRT_PONT,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "If my ability is set on '|esc\132Metal Flap|esc\128', then I can either start charging by holding jump or spin, or I can do another jump to then charge into.",
			next = 6
		},
		
		[6] = {
			name = "Cosmetal",
			portrait = PRT_STND,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "If, however, my ability is set on '|esc\132Hover|esc\128', then by holding jump, I can do a superior version of Vanilla |esc\132Metal Sonic|esc\128's Hover.",
			mini = {
				{portrait = {"cosmetal", A}, color = SKINCOLOR_METALLIX, text = "You kinda just...", pos = "dl"},
				{portrait = {"cosmetal", B}, color = SKINCOLOR_METALLIX, text = "Don't fall.", pos = "dr"}
			},
			next = 7
		},
		[7] = {
			name = "Cosmetal",
			portrait = PRT_EDGE,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "And to switch between abilities, I can use |wav|esc\131Custom1|esc\128|rst. Understood?",
			next = 8
		},
		[8] = {
			choices = {
				{text = "Yes", box = 11, pos = "left"},
				{text = "No", box = 9, pos = "right"}
			}
		},
		[9] = {
			name = "Cosmetal",
			portrait = PRT_PONT,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Ok, I'll go over it again.",
			next = 4
		},
		[10] = {
			name = "Cosmetal",
			portrait = PRT_PONT,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			script = function(p)
				if S_MusicName(p) != mapmusname
					S_ChangeMusic(mapmusname, true, p, 0, p.musPos, 0, 500)
				end
			end,
			text = "Oh, one last thing. If you want to do this tutorial again, type 'cms_tutorial' in the console. And if you want to change my settings, type 'cms_menu' or press FireNormal.",
			next = 3
		},
		[11] = {
			name = "Cosmetal",
			portrait = PRT_STND,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Ok, next thing.",
			next = 12
		},
		[12] = {
			name = "Cosmetal",
			portrait = PRT_PONT,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Jumping, then pressing the |wavSpin|rst button, I can do a jet boost.",
			next = 13
		},
		[13] = {
			name = "Cosmetal",
			portrait = PRT_PONT,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "With a shield, this jet boost can do different things. For example, the Whirlwind Shield makes me fly upwards while the boost is active.",
			next = 14
		},
		[14] = {
			name = "Cosmetal",
			portrait = PRT_STND,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Holding jump while jumping and then pressing Spin lets me use a shield's vanilla ability.",
			next = 15
		},
		[15] = {
			name = "Cosmetal",
			portrait = PRT_PONT,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Also, doing the same thing with all 7 Chaos Emeralds and enough rings without a shield allows me to turn super.",
			mini = {
				{portrait = {"cosmetal", C}, color = SKINCOLOR_METALLIX, text = "With cool music of course!", pos = "dr"}
			},
			next = 16
		},
		[16] = {
			name = "Cosmetal",
			portrait = PRT_MDJ,
			color = SKINCOLOR_METALLIX,
			text = "|del14*awesome music plays*",
			script = function(p)
				p.musPos = S_GetMusicPosition() - MUSICSTEP
				S_ChangeMusic("_super")
			end,
			delay = TICRATE*4,
			mini = {
				{portrait = {"cosmetal", A}, color = SKINCOLOR_METALLIX, text = "I love this song", pos = "dr"}
			},
			next = 10
		}
	},
	["eggrock"] = {
		[1] = {
			name = "Cosmetal",
			portrait = PRT_STND,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "|del14...Oh.",
			next = 2
		},
		[2] = {
			name = "Cosmetal",
			portrait = PRT_EDGE,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Egg Rock Zone. My|del14...|rst former home.",
			mini = {
				{portrait = {"cosmetal", B}, color = SKINCOLOR_METALLIX, text = "This place creeps me out...", pos = "dr"}
			},
			next = 3
		},
		[3] = {
			name = "Cosmetal",
			portrait = PRT_PONT,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Hopefully I can get out of here before Eggman gets me...",
			next = 0,
			script = function(p)
				CMS.Set("erz", true)
			end
		}
	},
	["aridcanyon"] = {
		[1] = {
			name = "Cosmetal",
			portrait = PRT_STND,
			color = SKINCOLOR_METALLIX,
			sound = sfx_talk0,
			text = "Ah, Arid Canyon. That 'Fang the Sniper' should be here. Once I meet him, I can get some answers.",
			next = 2
		},
		[2] = {
			name = "Cosmetal",
			portrait = PRT_QUES,
			sound = sfx_talk0,
			color = SKINCOLOR_METALLIX,
			text = "Like how does he shoot so skillfully?|pau17 Like seriously, how is he so good?",
			next = 3
		},
		[3] = {
			name = "Cosmetal",
			portrait = PRT_PONT,
			sound = sfx_talk0,
			color = SKINCOLOR_METALLIX,
			text = "Anyway, back to the mission.",
			script = function(p)
				CMS.Set("acz", true)
			end,
			next = 0
		}
	}
}

addHook("PlayerThink", function(p)
	if p.mo.skin == "cosmetal" and not p.textBox.tree and not multiplayer and CMS.Check("dialogue")
		if gamemap == 1 and CMS.Check("tutorial") == false
			CFTextBoxes:DisplayBox(p, CMS.DialogueBoxes["tutorial"])
		elseif gamemap == 22 and CMS.Check("erz") == false
			CFTextBoxes:DisplayBox(p, CMS.DialogueBoxes["eggrock"], false)
		elseif gamemap == 13 and CMS.Check("acz") == false
			CFTextBoxes:DisplayBox(p, CMS.DialogueBoxes["aridcanyon"], false)
		end
	end
end)

COM_AddCommand("cms_tutorial", function(p) CMS.Set("tutorial", false) end)

COM_AddCommand("cms_resetdialogue", function(p)
	CMS.Set("erz", false)
	CMS.Set("acz", false)
end)

local onoff = {[false] = "off", [true] = "on"}
COM_AddCommand("cms_dialogue", function(p)
	CMS.Toggle("dialogue")
	CONS_Printf(p, "Dialogue turned "..onoff[CMS.Check("dialogue")].."!")
end)

addHook("KeyDown", function(keyevent)
	if (consoleplayer and consoleplayer.textBox and consoleplayer.textBox.tree and not consoleplayer.textBox.move)
		if keyevent.num == 96 then
			return true
		end
	end
end)