CMS.MemeCheck = false

CMS.tunes = {
	[0] = "vsmetl",
	[1] = "bcz1",
	[2] = "lgrace"
}

//HoverThinker(player_t player) This really doesn't need a CMS function but whatever.
function CMS.HoverThinker(player)
	if player.vboosting
		player.secondjump = 0
	end
	if player.secondjump
		player.pflags = $|PF_CANCARRY
		if player.hyper and player.hyper.capable and player.powers[pw_super]
			player.mo.momz = max($,8*FRACUNIT*P_MobjFlip(player.mo))
		elseif player.powers[pw_super] or(player.solchar and player.solchar.istransformed)
			player.mo.momz = max($,4*FRACUNIT*P_MobjFlip(player.mo))
		else
			player.mo.momz = max($*P_MobjFlip(player.mo), 0)
		end
	end
end

function CMS.SpawnNewCamera(s, time)
	local ghs = P_SpawnMobj(s.x, s.y, s.z, MT_GARGOYLE)		
	ghs.flags2 = $|MF2_DONTDRAW
	ghs.angle = s.angle
	ghs.flags = $|MF_NOGRAVITY|MF_SOLID|MF_NOCLIPTHING & ~MF_PUSHABLE & ~MF_NOCLIP & ~MF_NOCLIPHEIGHT & ~MF_SHOOTABLE
	if (s.eflags & MFE_VERTICALFLIP)
		ghs.eflags = $|MFE_VERTICALFLIP
	end
	for d = 1,10 do
		P_TryMove(ghs, ghs.x+FixedMul(-25*FRACUNIT,cos(ghs.angle)), ghs.y+FixedMul(-25*FRACUNIT,sin(ghs.angle)), true)
	end
	ghs.flags = $ & ~MF_SOLID
	s.target = ghs
	
	s.player.awayviewmobj = ghs
	s.player.awayviewtics = time
end

//StartRocketBoost(player_t player, fixed speed, boolean ac, int sound, boolean setmomz)
function CMS.StartRocketBoost(player, speed, ac, sound, setmomz, startdash)
	player.start_speed = speed
	player.pflags = $ & ~PF_SPINNING
	P_InstaThrust(player.mo, player.mo.angle, speed)
	if startdash and not player.cmsHyper
		player.runtime = 25*FRACUNIT
	end
	player.rboost_setmomz = setmomz
	player.mo.state = S_PLAY_DASH
	player.rboosting = true
	if player.powers[pw_super]
		if player.hyper and player.hyper.capable
			player.boost_timer = TICRATE
		else
			player.boost_timer = TICRATE*3/4
		end
	else
		player.boost_timer = TICRATE/2
	end
	local cooldown
	if player.powers[pw_super] or (player.solchar and player.solchar.istransformed)
		if player.hyper and player.hyper.capable and player.powers[pw_super]
			cooldown = TICRATE*5/4
		else
			cooldown = TICRATE*5/2
		end
	else
		cooldown = TICRATE*5
	end
	if ac == true or ac == nil then player.boost_cooldown = cooldown end
	player.startangle = player.mo.angle
	if sound == nil then sound = sfx_kc40 end
	S_StartSound(player.mo, sound)
end

//MetalAura(mobj_t object, mobj_t target)
function CMS.MetalAura(mo,target)
	if not(target and target.valid and target.player and target.player.charging == true
	and target.player.charge_type == "blast"
		and target.player.playerstate == PST_LIVE)
		P_RemoveMobj(mo)
	return end
	mo.scale = target.scale
	if P_MobjFlip(target) == 1
		mo.eflags = $&~MFE_VERTICALFLIP
		P_MoveOrigin(mo,target.x,target.y,target.z+target.height/4)
	else
		mo.eflags = $|MFE_VERTICALFLIP
		P_MoveOrigin(mo,target.x,target.y,target.z+target.height*3/4)
	end
end

//EnergyGather(mobj_t object, mobj_t target, fixed_t xyangle, fixed_t zangle)
function CMS.EnergyGather(mo,target,xyangle,zangle)
	if not(target and target.valid and target.player and target.player.charging == true) then
		P_RemoveMobj(mo)
	return end
	local dist = mo.scale*4*16*mo.fuse
	local xydist = P_ReturnThrustX(nil,zangle,dist)
	local zdist = P_ReturnThrustY(nil,zangle,dist)
	local x = target.x+P_ReturnThrustX(nil,xyangle,xydist)
	local y = target.y+P_ReturnThrustY(nil,xyangle,xydist)
	local z = target.z+zdist+target.height/2
	P_SetOrigin(mo,x,y,z)
end

//StartCharge(player_t player, string effect)
function CMS.StartCharge(player, effect)
	if effect != "armageddon"
		S_StartSound(player.mo, sfx_bechrg)
	else
		S_StartSound(player.mo, sfx_s3k53)
	end
	if player.powers[pw_super] or effect == "blast"
		player.a = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ENERGYAURA)
		if player.a and player.a.valid then 
			player.a.target = player.mo
			player.a.scale = player.mo.scale
			player.a.spriteyoffset = -16*FRACUNIT
		end
	end
	local effects = {"blast","boost","armageddon"}
	if effect == nil or not effects[effect]
		player.charge_type = "boost"
	else
		player.charge_type = effect
	end
	player.charging = true
	if effect == "boost" or effect == "armageddon"
		player.speeddash = true
	end
	player.charge_speed = player.store_speed
	player.charge_timer = 0
end

local scales = {
	[1] = FRACUNIT*8/10,
	[2] = FRACUNIT*7/10,
	[3] = FRACUNIT*6/10
}
//SpawnMetalImage(player_t player)
function CMS.SpawnMetalImage(player, amount)
	local imagetable = {}
	for i = 1, amount do
		local metalimage = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_METALIMAGE)
		metalimage.source = player.mo
		metalimage.skin = player.mo.skin
		metalimage.state = player.mo.state
		metalimage.angle = player.drawangle
		metalimage.rollangle = player.mo.rollangle
		metalimage.spriteyoffset = player.mo.spriteyoffset
		metalimage.frame = player.mo.frame|FF_TRANS70
		metalimage.colorized = true
		metalimage.scale = scales[i]
		metalimage.imageID = i
		player.imagecount = $+1
		table.insert(imagetable, metalimage)
	end
	return imagetable
end

function CMS.ShieldToColor(player)
	if not player.powers[pw_shield]
		if not(player.cmsHyper)
			if player.cmsSuper
				return SKINCOLOR_METALLIX
			elseif player.darkform and player.darkform.on
				return SKINCOLOR_JET
			elseif player.solchar and player.solchar.istransformed
				return SKINCOLOR_SUPERGOLD3
			end
		else
			return SKINCOLOR_CMSHYPER
		end
	else
		if player.powers[pw_shield]&SH_NOSTACK == SH_ARMAGEDDON
			return SKINCOLOR_RED
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_WHIRLWIND
			return SKINCOLOR_CLOUDY
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_ELEMENTAL
			return SKINCOLOR_RUBY
		elseif (player.powers[pw_shield]&SH_FORCE)
			return SKINCOLOR_PURPLE
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_ATTRACT
			return SKINCOLOR_YELLOW
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_FLAMEAURA
			return SKINCOLOR_CRIMSON
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_BUBBLEWRAP
			return SKINCOLOR_COBALT
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_THUNDERCOIN
			return SKINCOLOR_WHITE
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_PITY
			return SKINCOLOR_APPLE
		end
	end
end

function CMS.SpawnMissile(mo, missile_type, angle)
	if angle == nil then angle = mo.angle end
	
	local m = P_SPMAngle(mo,missile_type,angle,1)
	return m
end

local function hasSolEmerald(player, num)
	if (player.solemeralds & (1 <<(num-1)))
	or (mpemeraldsave & (1 <<(num-1)))
		return true
	end
	
	return false
end

function CMS.drawEmeralds(v)
	if G_RingSlingerGametype() then return end
	if emeralds
		if (emeralds&EMERALD1)
			v.draw(301,18, v.cachePatch("CHAOS1"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD2)
			v.draw(301,41, v.cachePatch("CHAOS2"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD3)
			v.draw(301,64, v.cachePatch("CHAOS3"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD4)
			v.draw(301,87, v.cachePatch("CHAOS4"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD5)
			v.draw(301,110, v.cachePatch("CHAOS5"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD6)
			v.draw(301,133, v.cachePatch("CHAOS6"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if (emeralds&EMERALD7)
			v.draw(301,156, v.cachePatch("CHAOS7"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
	end
	
	if (consoleplayer.solchar and consoleplayer.solemeralds)
		if hasSolEmerald(consoleplayer,1)
			v.draw(297,43, v.cachePatch("TSEM1"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,2)
			v.draw(297,66, v.cachePatch("TSEM2"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,3)
			v.draw(297,89, v.cachePatch("TSEM3"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,4)
			v.draw(297,112, v.cachePatch("TSEM4"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,5)
			v.draw(297,135, v.cachePatch("TSEM5"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,6)
			v.draw(297,158, v.cachePatch("TSEM6"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
		
		if hasSolEmerald(consoleplayer,7)
			v.draw(297,181, v.cachePatch("TSEM7"), V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS)
		end
	end
end

function CMS.LaunchEffect(p, size, dir)
	local z = p.mo.height/2
	if P_MobjFlip(p.mo) == -1
		z = -p.mo.height/2
	else
		z = p.mo.height/2
	end
	
	local effect = P_SpawnMobjFromMobj(p.mo, 0, 0, z, MT_FACESTABBERSPEAR)
	effect.spriteyoffset = -2*FRACUNIT
	effect.flags = MF_SCENERY|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPTHING|MF_NOCLIPHEIGHT
	effect.frame = $ & (~FF_TRANS50)|FF_TRANS20
	effect.fuse = 5
	effect.tics = 5
	effect.color = ColorOpposite(p.skincolor)
	effect.colorized = true
	effect.scale = FixedMul(size, p.mo.scale)/3
	effect.destscale = FixedMul(size, p.mo.scale)*3/2
	effect.scalespeed = FRACUNIT/10
	if dir
		effect.renderflags = RF_PAPERSPRITE
		effect.angle = p.drawangle + ANGLE_90
	else
		effect.renderflags = RF_FLOORSPRITE
	end
end