-- HUD time --
CMS.HudType = "Vanilla"
CMS.HUDTypes = {
	["Vanilla"] = {1,2}
}

function CMS.AddHUDType(n, t)
	CMS.HUDTypes[n] = t
end

function CMS.SetHUDType(n)
	CMS.HudType = n
end

local switchY = 157
addHook("HUD",function(v, player)
	if not(player.mo and player.mo.valid) then return end
	
	//Cosmetal HUD
	if player.mo.skin == "cosmetal"
		
		local x,y
		//Cooldown bars
		if CMS.Check("liveshud")
			hud.disable("lives")
			local hudcolor
			if not player.cmsSuper
				hudcolor = SKINCOLOR_SILVER
			else
				hudcolor = SKINCOLOR_YELLOW
			end
			switchY = 157
			x,y = 3, 166
			local cooldown = player.boost_cooldown
			local cooldown2 = player.vboost_cooldown
			//Bars
			local bar2Y = y + 7
			local barpatch = v.cachePatch("BAR")
			v.drawStretched(x*FRACUNIT, y*FRACUNIT, 44*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, SKINCOLOR_CARBON))
			v.drawStretched(x*FRACUNIT, bar2Y*FRACUNIT, 70*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, SKINCOLOR_CARBON))
			if cooldown
				v.drawStretched(x*FRACUNIT, y*FRACUNIT, (cooldown/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, CMS.Variables["barcolor"].value))
			end
			if cooldown2
				v.drawStretched(x*FRACUNIT, bar2Y*FRACUNIT, (cooldown2/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, CMS.Variables["barcolor"].value))
			end
			v.drawString(x+5,y,"Jet Boost",V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_BLUEMAP|V_ALLOWLOWERCASE,"small-thin")
			v.drawString(x+5,y+7,"Metal Flap",V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_BLUEMAP|V_ALLOWLOWERCASE,"small-thin")
			
			v.draw(13, 193, v.getSprite2Patch("cosmetal", SPR2_LIFE, player.cmsSuper,A,0),V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT,v.getColormap("sonic", player.powers[pw_super] and player.mo.color or player.skincolor))
			v.draw(0,156,v.cachePatch("CMSLIVES"), V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT, v.getColormap(0, hudcolor))
			
			if player.lives != INFLIVES
				v.drawNum(58,183,player.lives,V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			else
				v.draw(58,183,v.cachePatch("STCFN022"),V_HUDTRANS|V_PERPLAYER|V_SNAPTOBOTTOM|V_SNAPTOLEFT)
			end
		else
			hud.enable("lives")
			//Bars
			x,y = hudinfo[HUD_LIVES].x,hudinfo[HUD_LIVES].y-9
			local cooldown = player.boost_cooldown
			local cooldown2 = player.vboost_cooldown
			//Define color vars for bars
			local color = CMS.Variables["barcolor"].value
			local color2 = SKINCOLOR_SUPERBLACKHOLE5
			local barpatch = v.cachePatch("BAR")
			switchY = 155
			
			if cooldown > 0
				v.drawStretched((x+1)*FRACUNIT, (y+1)*FRACUNIT, (cooldown/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color2))
				v.drawStretched(x*FRACUNIT, y*FRACUNIT, (cooldown/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color))
			end
			if cooldown2 > 0
				v.drawStretched((x+1)*FRACUNIT, (y-7)*FRACUNIT, (cooldown2/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color2))
				v.drawStretched(x*FRACUNIT, (y-8)*FRACUNIT, (cooldown2/4)*FRACUNIT, FRACUNIT, barpatch, V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS, v.getColormap(player.mo.skin, color))
			end
		end
		
		//Custom1 Ability Switch HUD
		if player.jumpabil == 1
			v.drawString(x, switchY, "Jump Ability: Metal Flap", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_ALLOWLOWERCASE|V_BLUEMAP,"small-thin")
		else
			v.drawString(x, switchY, "Jump Ability: Hover", V_SNAPTOBOTTOM|V_SNAPTOLEFT|V_PERPLAYER|V_HUDTRANS|V_ALLOWLOWERCASE|V_BLUEMAP,"small-thin")
		end
		
		local soundplaying, caption = CMS.MetalSoundPlaying(player.mo)
		if soundplaying and subtitles
			v.drawString(85, 185, "\132Cosmetal\128: "..caption, V_SNAPTOBOTTOM|V_PERPLAYER|V_HUDTRANS|V_ALLOWLOWERCASE)
		end
		
		if CMS.Check("liveshud")
			CMS.drawEmeralds(v)
			if not(player.solchar and player.solemeralds)
				v.draw(291,10,v.cachePatch("CMSEMERALDS"..CMS.HUDTypes[CMS.HudType][1]), V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTORIGHT)
			else
				v.draw(291,10,v.cachePatch("CMSEMERALDS"..CMS.HUDTypes[CMS.HudType][2]), V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTORIGHT)
			end
			v.drawString(298, 5, "Emeralds", V_SNAPTOTOP|V_SNAPTORIGHT|V_PERPLAYER|V_HUDTRANS|V_GREENMAP|V_ALLOWLOWERCASE, "thin-right")
		end
	else
		hud.enable("lives")
	end
end, "game")