addHook("ShouldJingleContinue", function(player, musname)
	if player and player.mo and player.mo.skin == "cosmetal" and player.metaldj and not (player.cmsSuper or (player.solchar and playersolchar.istransformed) or(player.darkform and player.darkform.on))
		return true
	else
		return false
	end
end)

addHook("MobjMoveBlocked", function(mo, thing, line)
	--Rocket Boost Bonk
	if not (mo.player and mo.skin == "cosmetal") return end
	local player = mo.player
	if player.rboosting and (line and line.valid) and not thing
		player.rboosting = false
		player.boost_timer = 0
		player.secondjump = 0
		if player.powers[pw_shield]&SH_NOSTACK == SH_ARMAGEDDON
			P_BlackOw(player)
			P_RemoveShield(player)
		end
		local shake = FRACUNIT*32
		if not(player.powers[pw_shield]&SH_FORCE or player.cmsSuper or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on))
			if(player == displayplayer)
				P_StartQuake(shake, TICRATE/3)
			end
			S_StartSound(mo, sfx_pstop)
			P_SetObjectMomZ(mo, 8*FRACUNIT)
			P_InstaThrust(mo, player.drawangle-ANGLE_180, 18*FRACUNIT)
			player.pflags = $ & ~PF_JUMPED
			player.rboost_canceled = true
			mo.state = S_PLAY_PAIN
		else
			P_InstaThrust(mo, player.drawangle-ANGLE_180, 32*FRACUNIT)
			if player.powers[pw_shield]&SH_FORCE
				P_SetObjectMomZ(mo, 16*FRACUNIT)
				S_StartSound(mo, sfx_ngskid)
				player.pflags = $|PF_SHIELDABILITY
			elseif player.cmsSuper or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on)
				if player.cmsHyper
					P_SetObjectMomZ(mo, 32*FRACUNIT)
					P_NukeEnemies(mo, mo, 1536*FRACUNIT)
					if (player == displayplayer)
						P_StartQuake(50*FRACUNIT, 10)
					end
				else
					P_SetObjectMomZ(mo, 24*FRACUNIT)
				end
				S_StartSound(mo, sfx_zoom)
			end
			mo.state = S_PLAY_SPRING
			player.pflags = $|PF_JUMPED
			player.boost_cooldown = 0
		end
	end
end)

addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cosmetal") then return end
	local mo = player.mo
	CMS.HoverThinker(player)
	
	if player.powers[pw_super]
		player.cmsSuper = true
	else
		player.cmsSuper = false
		player.cmsHyper = false
	end
	
	if player.cmsSuper
		if (player.hyper and player.hyper.capable and not (player.mo.state >= S_PLAY_HYPERTRNS_1 and player.mo.state < S_PLAY_HYPERTRNS_6))
			player.hyper.capable = false
			player.cmsHyper = true
		end
		if not(player.cmsHyper)
			if CMS.Check("supercolor") == 1
				mo.color = (SKINCOLOR_SUPERCOBALT1 + abs( ( (leveltime >> 1) % 9) - 4))
			elseif CMS.Check("supercolor") == 2
				mo.color = (SKINCOLOR_SUPERCRIMSON1 + abs( ( (leveltime >> 1) % 9) - 4))
			elseif CMS.Check("supercolor") == 3
				mo.color = (SKINCOLOR_SUPERGREEN1 + abs( ( (leveltime >> 1) % 9) - 4))
			elseif CMS.Check("supercolor") == 4
				mo.color = (SKINCOLOR_SUPERBLACKHOLE1 + abs( ( (leveltime >> 1) % 9) - 4))
			end
		else
			mo.color = SKINCOLOR_CMSHYPER
			if player.speed > FRACUNIT
				local aa = P_SpawnGhostMobj(mo)
				aa.fuse = 2
				aa.colorized = true
				aa.color = mo.color
			end
		end
	else
		if (player.superaura and player.superaura.valid)
			P_RemoveMobj(player.superaura)
		end
		player.cmsHyper = false
	end
	
	if leveltime % 3 == 0 and player.playerstate != PST_DEAD and CMS.Check("sparkles")
		local star = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-5,5)*FRACUNIT, P_RandomRange(-5,5)*FRACUNIT, player.mo.height/2+P_RandomRange(-5,5)*FRACUNIT, MT_BOXSPARKLE)
		star.momx = P_RandomRange(-2, 2) * FRACUNIT
		star.momy = P_RandomRange(-2, 2) * FRACUNIT
		star.momz =  P_RandomRange(-2, 2) * FRACUNIT
		star.source = player.mo
	end
	
	if player.cmsSuper or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on)
		if(player.panim == PA_WALK or player.panim == PA_RUN or player.panim == PA_DASH)
			player.mo.spriteyoffset = FRACUNIT*2 + (3 * cos(ANG10*leveltime))
		elseif player.idle
			player.mo.spriteyoffset = min((FRACUNIT*(player.waitTimer)), FRACUNIT*15 + (6 * cos(ANG10*player.waitTimer)))
		else
			player.mo.spriteyoffset = 0
		end
	else
		player.mo.spriteyoffset = 0
	end
	if player.powers[pw_carry] & CR_NIGHTSMODE then return end
	
	if player.metalshield != (player.powers[pw_shield] & SH_NOSTACK)
	and not G_IsSpecialStage()
		player.metalshield = (player.powers[pw_shield] & SH_NOSTACK)
	end
	
	player.hassupermusic = true
	
	if player.playerstate == PST_DEAD --Custom death animation
		player.rboosting = false
		player.boost_timer = 0
		player.vboosting = false
		player.vboost_timer = 0
		player.runtime = 0
		player.speeddash = false

		mo.flags = $ & ~MF_NOCLIPHEIGHT

		if P_IsObjectOnGround(mo)
			if CMS.Check("memes")
				mo.state = S_CMS_FLOORDEAD2
			else
				mo.state = S_CMS_FLOORDEAD
			end
			if player.deadalready
				mo.momx = 0
				mo.momy = 0
				mo.rollangle = 0
			end
		else
			mo.state = S_PLAY_DEAD
			if CMS.Check("memes")
				mo.sprite2 = SPR2_EROR
			end
			mo.rollangle = $ + ANG10
		end

		if not player.deadalready
			P_InstaThrust(mo, player.drawangle, player.prevspeed/2)
			mo.momz = 2*$/3
			player.deadalready = true
		end
	elseif player.deadalready
		player.charflags = $|SF_MACHINE
		player.deadalready = false
	end
	player.prevspeed = FixedHypot(mo.momx, mo.momy)
	
	if player.pflags&PF_STARTDASH
		player.camerascale = skins[player.mo.skin].camerascale/2
	else
		player.camerascale = skins[player.mo.skin].camerascale
	end
	
	player.idle = player.mo.state == S_PLAY_WAIT or player.mo.state == S_CMS_SWITCHOFF or player.mo.state == S_CMS_OFF
	
	if not player.idle
		player.waitTimer = 0
	else
		player.waitTimer = $+1
		if player.waitTimer == TICRATE*8
			player.mo.state = S_CMS_SWITCHOFF
		end
		if player.speed > 0
			player.mo.state = S_PLAY_STND
			player.idle = false
		end
		player.panim = PA_IDLE
	end
	
	if (CMS.Check("switchbutton") == 1 and player.cmd.buttons&BT_CUSTOM2) or (CMS.Check("switchbutton") == 0 and player.cmd.buttons&BT_CUSTOM1)
		if not player.tapped
			if player.jumpabil == 1
				player.jumpabil = 0
			else
				player.jumpabil = 1
			end
			S_StartSound(nil, sfx_kc5e, player)
		end
		player.tapped = true
	else
		player.tapped = false
	end

	player.metaldj = $ or false
	if player.cmd.buttons&BT_TOSSFLAG 
		if P_IsObjectOnGround(player.mo)
			if not player.dancetapped
				player.metaldj = not $
				if player.metaldj == true
					P_PlayJingleMusic(player, CMS.tunes[CMS.Check("metaltunes")], nil, true, JT_OTHER)
					player.pflags = $|PF_FULLSTASIS
				else
					if player.mo.state == S_CMS_METALDJ
						player.mo.state = S_PLAY_STND
					end
					P_RestoreMusic(player)
					player.pflags = $ & ~PF_FULLSTASIS
				end
			end
		end
		player.dancetapped = true
	else
		player.dancetapped = false
	end
	
	if player.metaldj
		player.pflags = $|PF_FULLSTASIS
		if player.mo.state != S_CMS_METALDJ
			player.mo.state = S_CMS_METALDJ
		end
	end
	
	if player.cmd.buttons&BT_CUSTOM3 and player.cmd.buttons&BT_ATTACK
		if not player.transformtapped
			if player.cmsSuper
				player.cmsSuper = false
				player.powers[pw_super] = 0
				P_SpawnShieldOrb(player)
				player.mo.color = player.skincolor
				P_RestoreMusic(player)
				player.mo.state = $
				player.charflags = $ & ~SF_SUPER
			elseif (player.solchar and player.solchar.istransformed)
				player.solchar.istransformed = 0
				player.mo.color = player.skincolor
				P_RestoreMusic(player)
				player.solchar.musicplaying = 0
				player.mo.eflags = $ & ~ MFE_FORCESUPER
				player.mo.state = $
			end
		end
		player.transformtapped = true
	else
		player.transformtapped = false
	end
	
	if player.speeddash
		if player.isxmomentum
			player.spcanflip = false
		end
		if player.pflags&PF_JUMPED and not(player.pflags&PF_THOKKED)
			local momz = player.mo.momz*P_MobjFlip(player.mo)
			if momz > 0
				player.mo.state = S_PLAY_SPRING
			else
				player.mo.state = S_PLAY_FALL
			end
		end
	else
		player.imagecount = 0
	end
	
	if not player.charging
	and not ((player.pflags&PF_STARTDASH) and player.mo.state == S_PLAY_METALAIM)
		if player.speeddash or player.cmsHyper
			A_BossScream(player.mo, 0, MT_WATERZAP)
		end
		if player.imagecount != 3 and player.speeddash
			local images = CMS.SpawnMetalImage(player, 3)
			local x = skincolors[ColorOpposite(player.skincolor)].ramp[5]
			local ramp = {x,x,x,x,x,x,x,x,x,x,x,x,x,x,x,x}
			skincolors[SKINCOLOR_METALIMAGE].ramp = ramp
			for _,image in pairs(images) do
				image.color = SKINCOLOR_METALIMAGE
			end
		end
	end
	
	if player.speeddash
		if (((leveltime-3)/2) & 1) and not player.cmsSuper and not(player.solchar and player.solchar.istransformed) and not(player.darkform and player.darkform.on)
			if not player.charging
				if CMS.Check("flashcolor")
					player.mo.colorized = true
					player.mo.color = CMS.Check("flashcolor")
				end
			else
				player.mo.colorized = true
				player.mo.color = SKINCOLOR_ORANGE
			end
		else
			if not player.cmsSuper and not (player.solchar and player.solchar.istransformed) and not (player.darkform and player.darkform.on)
				player.mo.color = player.skincolor
			end
			player.mo.colorized = false
		end
	else
		if not player.cmsSuper and not (player.solchar and player.solchar.istransformed) and not(player.darkform and player.darkform.on)
			player.mo.color = player.skincolor
		end
		player.mo.colorized = false
	end
	
	--Metal Flap stuff
	if P_IsObjectOnGround(player.mo)
		player.vboost_cooldown = 0
	end
	if P_IsObjectOnGround(player.mo)
		player.vboosts = 0
	end
	if player.vboost_cooldown > 0
		player.vboost_cooldown = $-1
	end
	if player.vboost_timer
		player.vboost_timer = max($-1, 0)
	end
	if player.vboosting
		if player.powers[pw_shield]&SH_NOSTACK == SH_THUNDERCOIN
			A_BossScream(player.mo, 0, MT_WATERZAP)
		end
	end
	if player.vboost_timer == 4 and player.vboosting
		local visualcue = P_SpawnGhostMobj(player.mo)
		visualcue.scale = player.mo.scale*3/2
		visualcue.destscale = player.mo.scale*2
		visualcue.scalespeed = FRACUNIT/20
	end
	if player.vboost_timer == 0 and player.vboosting
		if (not CMS.Check("abilswitch") and player.cmd.buttons&BT_SPIN) or (CMS.Check("abilswitch") and player.cmd.buttons&BT_JUMP)
			if player.powers[pw_shield]&SH_NOSTACK != SH_ARMAGEDDON
				CMS.StartCharge(player, "boost")
			else
				CMS.StartCharge(player, "armageddon")
			end
		elseif (not CMS.Check("abilswitch") and player.cmd.buttons&BT_JUMP) or (CMS.Check("abilswitch") and player.cmd.buttons&BT_SPIN)
			CMS.StartCharge(player, "blast")
		end
		player.vboosting = false
	end
	
	--Charge Code
	if player.charging and not P_IsObjectOnGround(player.mo)
		P_InstaThrust(player.mo, player.mo.angle, 0)
		player.secondjump = 0
		if(player.cmd.buttons&BT_SPIN or player.cmd.buttons&BT_JUMP)
		and player.charge_timer < TICRATE*3
			if (abilswitch == 1 and player.cmd.buttons&BT_JUMP) or (abilswitch == 2 and player.cmd.buttons&BT_SPIN)
				player.charge_type = "blast"
			elseif (abilswitch == 1 and player.cmd.buttons&BT_SPIN) or (abilswitch == 2 and player.cmd.buttons&BT_JUMP)
				player.charge_type = "boost"
			end
			if player.charge_type == "blast"
				if not player.a
					player.a = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z,MT_ENERGYAURA)
					if player.a and player.a.valid then 
						player.a.target = player.mo
						player.a.scale = player.mo.scale
						player.a.spriteyoffset = -16*FRACUNIT
					end
				end
				if player.charge_timer == TICRATE*3/2
					local visualcue = P_SpawnGhostMobj(player.mo)
					visualcue.scale = player.mo.scale*3/2
					visualcue.destscale = player.mo.scale*2
					visualcue.scalespeed = FRACUNIT/20
					S_StartSound(player.mo, sfx_s3kb3)
				end
				if player.charge_timer == TICRATE*5/2
					local visualcue = P_SpawnGhostMobj(player.mo)
					visualcue.scale = player.mo.scale*3/2
					visualcue.destscale = player.mo.scale*2
					visualcue.scalespeed = FRACUNIT/20
					S_StartSound(player.mo, sfx_s3kb31)
				end
				player.t = P_LookForEnemies(player, false, true)
				if player.t
					player.mo.angle = R_PointToAngle2(player.mo.x, player.mo.y, player.t.x, player.t.y)
					player.drawangle = player.mo.angle
					P_SpawnLockOn(player, player.t, S_LOCKON3)
				end
			end
			player.mo.state = S_PLAY_METALAIM
			player.charge_timer = $+1
			if not player.cmsSuper or not(player.solchar and player.solchar.istransformed) or not(player.darkform and player.darkform.on)
				player.charge_speed = min($+FRACUNIT, FRACUNIT*170)
			else
				player.charge_speed = min($+FRACUNIT*2, FRACUNIT*340)
			end
			local gather = P_SpawnMobj(player.mo.x,player.mo.y,player.mo.z+player.mo.height/2,MT_ENERGYGATHER)
			if gather and gather.valid then
				gather.target = player.mo
				gather.fuse = 35
				gather.extravalue1 = P_RandomRange(0,359)*ANG1
				gather.extravalue2 = P_RandomRange(0,359)*ANG1
				gather.scale = player.mo.scale/4
			end
			if player.charge_timer == 2*TICRATE
			and (player.charge_type == "boost" or player.charge_type == "armageddon")
				local visualcue = P_SpawnGhostMobj(player.mo)
				visualcue.scale = player.mo.scale*3/2
				visualcue.destscale = player.mo.scale*2
				visualcue.scalespeed = FRACUNIT/20
			end
		else
	//The outcome of the charge
			if player.charge_type == "boost" // Rocket Boost
				S_StopSoundByID(player.mo, sfx_bechrg)
				CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
			elseif player.charge_type == "armageddon" // Rocket Boost w/ Armageddon Shield
				S_StopSoundByID(player.mo, sfx_s3k53)
				CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
			elseif player.charge_type == "blast" // Laser Blast
				S_StopSoundByID(player.mo, sfx_bechrg)
				S_StartSound(player.mo, sfx_s3k54)
				player.mo.state = S_PLAY_SPRING
				P_InstaThrust(player.mo, player.drawangle+ANGLE_180, 8*FRACUNIT)
				local blast
				local blast2
				local blast3
				local blast4
				local blast5
				if player.t
					blast = P_SpawnPointMissile(player.mo, player.t.x, player.t.y, player.t.z, MT_ENERGYBLAST, player.mo.x, player.mo.y, player.mo.z)
				else
					blast = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST)
				end
				if player.charge_timer >= TICRATE*3/2
					blast.scale = FRACUNIT*5/4
					blast2 = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST, player.drawangle-(ANGLE_22h/2))
					if (blast2 and blast2.valid)
						blast2.scale = FRACUNIT*3/4
					end
					blast3 = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST, player.drawangle+(ANGLE_22h/2))
					if (blast3 and blast3.valid)
						blast3.scale = FRACUNIT*3/4
					end
				end
				
				if player.charge_timer >= TICRATE*5/2
					blast.scale = FRACUNIT*2
					blast4 = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST, player.drawangle-ANGLE_22h)
					blast4.scale = FRACUNIT/2
					blast5 = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST, player.drawangle+ANGLE_22h)
					blast5.scale = FRACUNIT/2
				end
	//Missile Handling
				if blast and blast.valid then
					if not player.t
						P_InstaThrust(blast, blast.angle, 32*blast.scale)
					end
					if G_GametypeHasTeams() then
						blast.colorized = true
						blast.color = player.mo.color
					end
					if (player.b != nil and player.b.valid) and (player.c != nil and player.c.valid)
						P_InstaThrust(player.b, player.b.angle, 32*player.b.scale)
						P_InstaThrust(player.c, player.c.angle, 32*player.c.scale)
						if G_GametypeHasTeams()
							player.b.colorized = true
							player.c.colorized = true
							player.b.color = player.mo.color
							player.c.color = player.mo.color
						end
					end
				end
			end
			player.charging = false
		end
		if player.charge_timer == 3*TICRATE
			if player.charge_type == "boost"
				S_StopSoundByID(player.mo, sfx_bechrg)
				CMS.StartRocketBoost(player, player.charge_speed, false, sfx_s3k54, false)
				player.charging = false
			elseif player.charge_type == "blast"
				S_StopSoundByID(player.mo, sfx_bechrg)
				S_StartSound(player.mo, sfx_s3k54)
				player.mo.state = S_PLAY_SPRING
				P_InstaThrust(player.mo, player.drawangle+ANGLE_180, 8*FRACUNIT)
				local blast
				local blast2
				local blast3
				local blast4
				local blast5
				if player.t
					blast = P_SpawnPointMissile(player.mo, player.t.x, player.t.y, player.t.z, MT_ENERGYBLAST, player.mo.x, player.mo.y, player.mo.z)
				else
					blast = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST)
				end
				blast.scale = FRACUNIT*2
				blast2 = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST, player.drawangle-ANGLE_22h)
				blast2.scale = FRACUNIT/2
				blast3 = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST, player.drawangle+ANGLE_22h)
				blast3.scale = FRACUNIT/2
				blast4 = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST, player.drawangle-(ANGLE_22h/2))
				blast4.scale = FRACUNIT*3/4
				blast5 = CMS.SpawnMissile(player.mo, MT_ENERGYBLAST, player.drawangle+(ANGLE_22h/2))
				blast5.scale = FRACUNIT*3/4
				if blast and blast.valid then
					if not player.t
						P_InstaThrust(blast, blast.angle, 32*blast.scale)
					end
					if G_GametypeHasTeams() then
						blast.colorized = true
						blast.color = player.mo.color
					end
					if (player.b != nil and player.b.valid) and (player.c != nil and player.c.valid)
						P_InstaThrust(player.b, player.b.angle, 32*player.b.scale)
						P_InstaThrust(player.c, player.c.angle, 32*player.c.scale)
						if G_GametypeHasTeams()
							player.b.colorized = true
							player.c.colorized = true
							player.b.color = player.mo.color
							player.c.color = player.mo.color
						end
					end
				end
			end
			player.charging = false
		end
		if not S_SoundPlaying(player.mo, sfx_s3k54) and player.charge_type == "armageddon"
			P_BlackOw(player)
			P_RemoveShield(player)
			CMS.StartRocketBoost(player, 120*FRACUNIT, false, sfx_s3k54, false)
		end
		P_SetObjectMomZ(player.mo, -FRACUNIT/2)
		player.mo.spriteyoffset = (4 * cos(ANG10*leveltime))
	elseif player.charging
		player.charging = false
		S_StopSoundByID(player.mo, sfx_bechrg)
		S_StopSoundByID(player.mo, sfx_s3k53)
	end
	if player.charge_timer == nil or P_IsObjectOnGround(player.mo)
		player.charge_timer = 0
	end
	if player.canbounce == nil or P_IsObjectOnGround(player.mo)
		player.canbounce = false
	end
	if player.sound_done == nil or P_IsObjectOnGround(player.mo)
		player.sound_done = false
	end
	if player.store_speed == nil or P_IsObjectOnGround(player.mo)
		player.store_speed = 0
	end
	if player.charge_type == nil or P_IsObjectOnGround(player.mo)
		player.charge_type = "none"
	end
	
	if not ((player.cmd.buttons & BT_JUMP)
	and (player.pflags & PF_JUMPED))
		player.charflags = $|SF_NOSHIELDABILITY
		if not player.powers[pw_super]
			player.charflags = $ & ~SF_SUPER
		end
	else
		player.charflags = $|SF_SUPER
		player.charflags = $&~SF_NOSHIELDABILITY
	end
	
--	 Rocket Boost Stuff --
	if player.rboost_setmomz == nil or P_IsObjectOnGround(player.mo)
	or player.mo.eflags&MFE_SPRUNG
		player.rboost_setmomz = false
	end
	if player.mo.eflags&MFE_SPRUNG
		if player.rboosting
			player.mo.momx = $*5/4
			player.mo.momy = $*5/4
			player.mo.momz = $*5/4
			S_StartSound(player.mo, sfx_sprong)
		end
		player.boost_cooldown = 0
		player.vboost_cooldown = 0
		player.rboosting = false
		player.rboost_timer = 0
	end

	if player.boost_cooldown == nil or P_IsObjectOnGround(player.mo)
		player.boost_cooldown = 0
	end
	if player.boost_cooldown > 0
		player.boost_cooldown = $-1
	end
	if player.rboost_canceled == nil
		player.rboost_canceled = false
	end
	if player.rboost_canceled 
	and (P_IsObjectOnGround(player.mo) or player.mo.eflags&MFE_SPRUNG)
		player.rboost_canceled = false
		player.viewrollangle = 0
		player.mo.rollangle = 0
		player.drawangle = player.startangle
	end
	if player.rboost_canceled
		player.mo.rollangle = $+ANGLE_22h
		player.drawangle = $+ANGLE_22h
		player.powers[pw_nocontrol] = 1
		player.runtime = 0
		player.speeddash = false
	end
	if player.boost_timer
		player.boost_timer = max($-1,0)
	end
	if player.rboosting
		if (player.cmsSuper or player.solchar and player.solchar.istransformed or player.darkform and player.darkform.on) and player.boost_timer % 2 == 0 and player.boost_timer > 0
			CMS.LaunchEffect(player, FRACUNIT*3/2, 1)
		elseif player.boost_timer % 4 == 0 and player.boost_timer > 0
			CMS.LaunchEffect(player, FRACUNIT, 1)
		end
		if player.rboost_setmomz
			if player.powers[pw_shield]&SH_NOSTACK == SH_WHIRLWIND
			or (player.powers[pw_shield]&SH_NOSTACK == SH_THUNDERCOIN)
				if (player.powers[pw_shield]&SH_NOSTACK == SH_THUNDERCOIN)
					A_BossScream(player.mo, 0, MT_WATERZAP)
				end
				P_SetObjectMomZ(player.mo, FRACUNIT*24)
			elseif (player.powers[pw_shield]&SH_NOSTACK == SH_ELEMENTAL)
			or (player.powers[pw_shield]&SH_NOSTACK == SH_BUBBLEWRAP)
				P_SetObjectMomZ(player.mo, -FRACUNIT*24)
			else
				P_SetObjectMomZ(player.mo, 0)
			end
		end
		if (player.powers[pw_shield]&SH_NOSTACK == SH_FLAMEAURA)
		or player.powers[pw_shield]&SH_NOSTACK == SH_ELEMENTAL
			P_InstaThrust(player.mo, player.drawangle, player.start_speed+40*FRACUNIT)
		else
			P_InstaThrust(player.mo, player.drawangle, player.start_speed)
		end
		player.mo.state = S_PLAY_DASH
		if player.followmobj
			local jetghost = P_SpawnGhostMobj(player.followmobj)
			jetghost.fuse = 3
			jetghost.color = jetcolor or SKINCOLOR_YELLOW
			jetghost.scalespeed = FRACUNIT/4
			jetghost.destscale = 0
		end
	end
	
	if player.boost_timer == 0 and player.rboosting
	or P_IsObjectOnGround(player.mo) and player.rboosting
		if not P_IsObjectOnGround(player.mo) and not player.secondjump
		and not player.rboost_canceled
		and player.rboost_setmomz
			player.mo.state = S_PLAY_FALL
		end
		if player.powers[pw_shield]&SH_FORCE and player.powers[pw_shield]&SH_FORCEHP
		and not P_IsObjectOnGround(player.mo)
			P_InstaThrust(player.mo, player.drawangle, player.speed/2)
			S_StartSound(player.mo, sfx_ngskid)
			player.pflags = $|PF_SHIELDABILITY
		elseif player.powers[pw_shield]&SH_NOSTACK == SH_ARMAGEDDON
		and not P_IsObjectOnGround(player.mo)
			P_BlackOw(player)
			P_RemoveShield(player)
		end
		player.rboosting = false
	end
	
	player.mo.prevz = player.mo.z
end)

addHook("JumpSpinSpecial",function(player)
	--Rocket Boost
	if not (player.mo and player.mo.valid and player.mo.skin == "cosmetal") then return end
	if not(player.pflags&PF_USEDOWN)
	and player.boost_cooldown == 0
	and not player.vboosting
	and not player.charging
	and (not(player.cmd.buttons&BT_JUMP and player.rings > 49 and All7Emeralds(emeralds)) or player.cmsSuper)
		if player.powers[pw_shield]&SH_NOSTACK == SH_PITY then S_StartSound(player.mo, sfx_pity) end

		if player.cmsHyper and player.cmsSuper
			CMS.StartRocketBoost(player, player.speed+170*FRACUNIT, true, sfx_kc40, true, true)
		elseif player.cmsSuper or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on)
			CMS.StartRocketBoost(player, player.speed+85*FRACUNIT, true, sfx_kc40, true, true)
		else
			CMS.StartRocketBoost(player, player.speed+50*FRACUNIT, true, sfx_kc40, true, true)
		end
		CMS.LaunchEffect(player, FRACUNIT, 1)
		return true
	end
end)

addHook("AbilitySpecial", function(player)
	if not (player.mo and player.mo.valid and player.mo.skin == "cosmetal") then return end
	if player.jumpabil == 1
		local water = 1+(player.mo.eflags&MFE_UNDERWATER)/MFE_UNDERWATER
		if player.vboost_cooldown == 0
		and not player.rboosting
		and not player.charging
			if player.vboosts == 0
				P_InstaThrust(player.mo, player.drawangle, player.speed)
				player.store_speed = max(player.speed, 20*FRACUNIT)
				player.force = 10*FRACUNIT
				P_SetObjectMomZ(player.mo, player.force/water)
				S_StartSound(player.mo, sfx_beflap)
				player.pflags = $ & ~PF_SPINNING
				player.vboost_timer = TICRATE*3/4
				player.vboosting = true
				player.vboost_cooldown = TICRATE/4
				player.mo.state = S_PLAY_SPRING
				player.vboosts = 1
				CMS.LaunchEffect(player, FRACUNIT)
			else
				P_InstaThrust(player.mo, player.drawangle, player.speed)
				player.store_speed = max(player.speed, 20*FRACUNIT)
				if player.cmsHyper and player.cmsSuper
					player.force = 32*FRACUNIT
				elseif player.cmsSuper or (player.solchar and player.solchar.istransformed) or(player.darkform and player.darkform.on)
					player.force = 24*FRACUNIT
				else
					player.force = 16*FRACUNIT
				end
				P_SetObjectMomZ(player.mo, (player.force+player.speed/16)/water)
				S_StartSound(player.mo, sfx_beflap)
				player.pflags = $ & ~PF_SPINNING
				player.vboost_timer = TICRATE*3/4
				player.vboosting = true
				if player.cmsSuper or(player.solchar and player.solchar.istransformed)
					if player.cmsHyper and player.cmsSuper
						player.vboost_cooldown = TICRATE*2
					else
						player.vboost_cooldown = TICRATE*4
					end
				else
					player.vboost_cooldown = TICRATE*8
				end
				player.mo.state = S_PLAY_SPRING
				CMS.LaunchEffect(player, FRACUNIT*2)
			end
		end
		if player.jumpabil == 1
			return true
		end
	end
end)